﻿using System;

Console.WriteLine("Witaj Świecie");

namespace CS9
{
    public record Osoba
    {
        public string Imię { get; init; }
        public string Nazwisko { get; init; }
        public int NumerTelefonu { get; set; }

        public Osoba(string imię, string nazwisko)
        {
            Imię = imię;
            Nazwisko = nazwisko;
        }

        public override string ToString()
        {
            return $"{Imię} {Nazwisko}, {NumerTelefonu}";
        }

        /*
        public override bool Equals(object obj)
        {
            if (obj is Osoba)
            {
                Osoba _obj = obj as Osoba;
                return Imię == _obj.Imię && Nazwisko == _obj.Nazwisko && NumerTelefonu == _obj.NumerTelefonu;
            }
            else return false;
        }
        */
    }

    public record Student : Osoba
    {
        public int NumerLegitymacji { get; init; }

        public Student(string imię, string nazwisko, int numerLegitymacji)
            :base(imię, nazwisko)
        {
            NumerLegitymacji = numerLegitymacji;
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            #region Rekordy
            Osoba o = new Osoba("Mikołaj", "Kopernik")
            {
                NumerTelefonu = 123456789
            };
            Console.WriteLine(o);

            /*
            Osoba jm = new Osoba()
            {
                Imię = "Jacek",
                Nazwisko = "Matulewski",
                NumerTelefonu = 0987654321
            };
            */
            /*
            Osoba jm = new Osoba()
            {
                Imię = o.Imię,
                Nazwisko = o.Nazwisko,
                NumerTelefonu = o.NumerTelefonu
            };
            */
            //Osoba jm = o;
            //Osoba jm = o with { };
            Osoba jm = o with { Imię = o.Imię + "1" };
            Console.WriteLine(jm);

            Console.WriteLine(o == jm);
            Console.WriteLine(o.Equals(jm));

            //o.Imię = "Katarzyna";
            //o.NumerTelefonu = 1458937458;
            //Console.WriteLine(o);
            #endregion

            for (int i = 0; i < 100; ++i)
            {
                Random r = new Random();
                int n = r.Next(8);
                /*
                string opis = "";
                switch (n)
                {
                    case 1 or 7:
                        opis = "weekend";
                        break;
                    //case 2 or 3 or 4 or 5 or 6:
                        //opis = "dzień roboczy";
                        //break;
                    case >= 2 and <= 6:
                        opis = "dzień roboczy";
                        break;
                    default:
                        opis = "błąd!";
                        break;
                }
                */
                string opis = n switch
                {
                    1 or 7 => "weekend",
                    >= 2 and <=6 => "dzień roboczy",
                    _ => "błąd!"
                };
                Console.WriteLine(n + " " + opis);
            }
        }
    }
}
